#ifndef QUESTION_H
#define QUESTION_H

#include <string>

using namespace std;

class Question
{
public:
   /**
      Konstruuje pytanie z pustym tekstem i odpowiedzią.
   */
   Question();

   /**
      @param question_text tekst pytania
   */
   void set_text(string question_text);

   /**
      @param correct_response właściwa odpowiedź na pytanie
   */
   void set_answer(string correct_response);

   /**
      @param response odpowiedź do sprawdzenia
      @return wartość true, jeśli odpowiedź jest poprawna, w przeciwnym razie wartość false
   */
   virtual bool check_answer(string response) const;   

   /**
      Wyświetla pytanie.
   */
   virtual void display() const;
private:
   string text;
   string answer;
};

#endif

